/*************************************************************************
 *                        Boar 's Only A Raytracer                       *
 *                                                                       *
 *       Copyright (C) 2014  Holger Bettag  (hobold@vectorizer.org)      *
 *                                                                       *
 * This program is free software: you can redistribute it and/or modify  *
 * it under the terms of the GNU General Public License as published by  *
 * the Free Software Foundation, either version 3 of the License, or     *
 * (at your option) any later version.                                   *
 *                                                                       *
 * This program is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 * GNU General Public License for more details.                          *
 *                                                                       *
 * You should have received a copy of the GNU General Public License     *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 *************************************************************************/

#ifndef MATERIAL_H
#define MATERIAL_H

#include <stdint.h>

#include "calc.h"
#include "simplelist.h"

class Scene;  // name declaration

class Material {
 public:
  Material(Vec3 Pigment, double Diffuse, double Ambient,
	   double HighlightIntensity, double HighlightSize,
	   double Reflection = 0.0);

  inline Vec3 getPigment(void) {
    return colour;
  };

  // do the lighting
  // ray direction, position of hit, normal at hit
  // recursive depth counter
  Vec3 lighting(Vec3 Dir, Vec3 Pos, Vec3 Normal, const Scene& theScene,
#if defined(ANTIALIAS)
		uintptr_t& Hash,
#endif  // defined(ANTIALIAS)
		int Depth = 0) const;

  Vec3 colour;
  double diffuse;
  double ambient;
  double hiliteIntensity;
  double hiliteSize;
  double reflection;
};


#endif // MATERIAL_H
