/*************************************************************************
 *                        Boar 's Only A Raytracer                       *
 *                                                                       *
 *       Copyright (C) 2014  Holger Bettag  (hobold@vectorizer.org)      *
 *                                                                       *
 * This program is free software: you can redistribute it and/or modify  *
 * it under the terms of the GNU General Public License as published by  *
 * the Free Software Foundation, either version 3 of the License, or     *
 * (at your option) any later version.                                   *
 *                                                                       *
 * This program is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 * GNU General Public License for more details.                          *
 *                                                                       *
 * You should have received a copy of the GNU General Public License     *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 *************************************************************************/

#ifndef RAY_H
#define RAY_H

#include "calc.h"

struct Ray {
  Vec3 base;
  Vec3 dir;

  // scale direction vector to unit length
  inline void normalize(void) {
    dir.normalize();
  };

  // find point on Ray
  inline Vec3 evaluate(double t) const {
    return Vec3(base.x + t*dir.x,
		base.y + t*dir.y,
		base.z + t*dir.z);
  };
};

#endif // RAY_H
