/*************************************************************************
 *                        Boar 's Only A Raytracer                       *
 *                                                                       *
 *       Copyright (C) 2014  Holger Bettag  (hobold@vectorizer.org)      *
 *                                                                       *
 * This program is free software: you can redistribute it and/or modify  *
 * it under the terms of the GNU General Public License as published by  *
 * the Free Software Foundation, either version 3 of the License, or     *
 * (at your option) any later version.                                   *
 *                                                                       *
 * This program is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 * GNU General Public License for more details.                          *
 *                                                                       *
 * You should have received a copy of the GNU General Public License     *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 *************************************************************************/

#ifndef TRACE_H
#define TRACE_H

#include <stdint.h>

#include "ray.h"
#include "simplelist.h"
#include "geobject.h"
#include "scene.h"

// core routine, traces a ray and returns a colour
Vec3 TraceRay(Ray& ray, const Scene& scene,
#if defined(ANTIALIAS)
	      uintptr_t& Hash,
#endif  // defined(ANTIALIAS)
	      int Depth = 0);

// utility routine, traces a ray and returns closest hit beyond minDist
// corresponding ray parameter is returned via reference
// in case of miss, GeObject is NULL, and ray parameter is MAXNUM
GeObject* ClosestHit(Ray& ray, const Scene& scene,
		     double minDist, double& where, int& Splits);

// utility routine, traces a ray and returns any hit (for shadow calculations)
// in case of miss, GeObject is NULL
GeObject* AnyHit(Ray& ray, const Scene& scene,
		 double maxDist);

#endif // TRACE_H
