/*************************************************************************
 *                        Boar 's Only A Raytracer                       *
 *                                                                       *
 *       Copyright (C) 2014  Holger Bettag  (hobold@vectorizer.org)      *
 *                                                                       *
 * This program is free software: you can redistribute it and/or modify  *
 * it under the terms of the GNU General Public License as published by  *
 * the Free Software Foundation, either version 3 of the License, or     *
 * (at your option) any later version.                                   *
 *                                                                       *
 * This program is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 * GNU General Public License for more details.                          *
 *                                                                       *
 * You should have received a copy of the GNU General Public License     *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 *************************************************************************/

#ifndef TRANSFORM_H
#define TRANSFORM_H

#include "calc.h"

class Transform {
 public:
  // initialize with identity
  Transform(void);

  // custom Transform
  Transform(const Vec3& Col1, const Vec3& Col2, const Vec3& Col3,
	    const Vec3& Affine);

  // accumulate further movements
  void RotateX(double angle);  // angles in degrees
  void RotateY(double angle);
  void RotateZ(double angle);

  void Scale(const Vec3& factors);
  
  void Translate(const Vec3& offset);

  void Apply(const Transform& trans);

  Vec3 ApplyTo(const Vec3& vec) const;

  // transform a vector by only the linear part
  Vec3 MatxVec(const Vec3& vec) const;

  Vec3 column[3];  // linear part
  Vec3 affine;     // translation part
};

#endif // TRANSFORM_H
